"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const doBootstrapHandler = (env, {
  name,
  assets,
  api,
  manifest
}) => async (req, res) => {
  var _env$api, _env$api2, _env$assets, _env$assets2, _env$assets3;

  // Retrieve the manifest file contents
  let manifestData = _fs.default.readFileSync(manifest.filepath, 'utf8'); // Determine the correct api and asset values based on


  const apiUrl = ((_env$api = env.api) === null || _env$api === void 0 ? void 0 : _env$api.url) || api.url;
  const apiPath = ((_env$api2 = env.api) === null || _env$api2 === void 0 ? void 0 : _env$api2.path) || api.path;
  const assetUrl = ((_env$assets = env.assets) === null || _env$assets === void 0 ? void 0 : _env$assets.url) || apiUrl;
  const assetTarget = ((_env$assets2 = env.assets) === null || _env$assets2 === void 0 ? void 0 : _env$assets2.target) || assets.target;
  const assetEnv = ((_env$assets3 = env.assets) === null || _env$assets3 === void 0 ? void 0 : _env$assets3.env) || {}; // Replace the bootstrap JS placeholder tokens with permitted environment variables
  // This will be used by bootstrap and communicated within the window space to the built micro UI assets

  let contents = _fs.default.readFileSync(_path.default.join(process.cwd(), 'node_modules/@sackrin/react-micro-ui/lib/bootstrap', 'bootstrap.js'), 'utf8');

  contents = contents.replace(/__MANIFEST__/g, manifestData);
  contents = contents.replace(/__ENV__/g, JSON.stringify({
    name,
    apiUrl,
    apiPath,
    assetUrl: assetUrl || apiUrl,
    assetTarget,
    assetEntry: manifest.entry || 'main.js',
    ...assetEnv
  })); // WARNING! Try everything we can to make sure the assets are NOT cached
  // This is the worst file to have cached, ensure this file does not cache

  res.set('Content-Type', 'application/javascript');
  res.set('Cache-Control', 'private, no-cache, no-store, must-revalidate');
  res.set('Expires', '-1');
  res.set('Pragma', 'no-cache');
  res.sendStatus(200);
  res.send(contents);
};

var _default = doBootstrapHandler;
exports.default = _default;